package com.mossle.bpm.delegate;

import java.util.Date;
import java.util.List;
import java.util.Map;
import javax.annotation.Resource;

import com.mossle.bpm.support.DefaultTaskListener;
import org.activiti.engine.delegate.DelegateTask;
import org.activiti.engine.delegate.TaskListener;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Component;

@Component("delegateTaskListener")
public class DelegateTaskListener extends DefaultTaskListener {
    private static Logger logger = LoggerFactory
            .getLogger(DelegateTaskListener.class);

	private DelegateService delegateService;

	@Override
	public void onAssignment(DelegateTask delegateTask) throws Exception {
		String assignee = delegateTask.getAssignee();
		String processDefinitionId = delegateTask.getProcessDefinitionId();
		DelegateInfo delegateInfo = delegateService.getDelegateInfo(assignee, processDefinitionId);
		if (delegateInfo == null) {
			return;
		}

		String attorney = delegateInfo.getAttorney();
		delegateTask.setAssignee(attorney);
		delegateService.saveRecord(assignee, attorney, delegateTask.getId());
	}

	@Resource
	public void setDelegateService(DelegateService delegateService) {
		this.delegateService = delegateService;
	}
}
