
create table bpm_delegate_info(
	id bigint generated by default as identity primary key,
	assignee varchar(200),
	attorney varchar(200),
	start_time timestamp,
	end_time timestamp,
	process_definition_id varchar(100),
	status int
);

-- insert into bpm_delegate_info(assignee,attorney,status) values('user1','user3',1);

create table bpm_delegate_history(
	id bigint generated by default as identity primary key,
	assignee varchar(200),
	attorney varchar(200),
	delegate_time timestamp,
	task_id varchar(100),
	status int
);


CREATE SEQUENCE INDEX_bpm_delegate_info_SEQ INCREMENT BY 1  START WITH 1 NOMAXVALUE NOCYCLE CACHE 10; 
     
create or replace trigger trigger_bpm_delegate_info_ID_PK BEFORE
insert ON  bpm_delegate_info FOR EACH ROW
begin
	select INDEX_bpm_delegate_info_SEQ.nextval into:New.id from dual;
end;

CREATE SEQUENCE INDEX_bpm_delegate_history_SEQ INCREMENT BY 1  START WITH 1 NOMAXVALUE NOCYCLE CACHE 10; 
     
create or replace trigger trigger_bpm_delegate_history_ID_PK BEFORE
insert ON  bpm_delegate_history FOR EACH ROW
begin
	select INDEX_bpm_delegate_history_SEQ.nextval into:New.id from dual;
end;

